<template>
  <div>
    <rui-empty v-if="elements.length === 0" class="-md" :content="$t('js.inventory.no_element_to_display')" inline />
    <details v-if="showRotationGroups && (nextRotationGroups || implantedRotationGroups)" class="-mvd rui-widget">
      <summary class="rui-widget__header">
        <span class="rui-widget__header__title">{{ $t('js.inventory.crop_rotation_groups') }}</span>
        <span class="rui-widget__header__actions">
          <gpa-crop-rotation-help-button :next-rotation-groups="nextRotationGroups" />
        </span>
      </summary>
      <div class="-pbs -phd">
        <section v-if="nextRotationGroups" class="-mtd">
          <div class="-text--small">{{ $t('generic.definition', {value: $t('js.patch.next_rotation_groups')}) }}</div>
          <gpa-crop-rotation-group-tags :groups-with-counts="nextRotationGroups" blocks />
        </section>

        <section v-if="showRotationGroups && implantedRotationGroups" class="-mtd">
          <div class="-text--small">{{ $t('generic.definition', {value: $t('js.patch.current_rotation_groups')}) }}</div>
          <gpa-crop-rotation-group-tags :groups-with-counts="implantedRotationGroups" blocks />
        </section>
      </div>
    </details>

    <rui-list-item v-for="element in groupedElements.notRemoved"
                   :key="element.id"
                   :to="{name: routeName, params: { elementId: element.id }}"
                   :active="isActive(element.id)"
                   :caption="element.displayName"
                   :image="element.resource.picturePath" />

    <div v-if="groupedElements.removed.years.length > 0" class="-text--medium -ptd">{{ $t('js.inventory.removed_elements') }}</div>
    <rui-collapsible-list-item v-for="year in groupedElements.removed.years" :key="year" class="-mts">
      <template #caption>
        <div class="-flex -gap -align-items-start">
          <strong>{{ year }}</strong>
          <small class="-flex-column -align-items-start">
            <gpa-crop-rotation-group-tags v-if="showRotationGroups" :groups-with-counts="groupedElements.removed.entries[year].rotationGroups" size="small" />
            <span>{{ groupedElements.removed.entries[year].names }}</span>
          </small>
        </div>
      </template>

      <rui-list-item v-for="element in groupedElements.removed.entries[year].elements"
                     :key="element.id"
                     :to="{name: routeName, params: { elementId: element.id }}"
                     :active="isActive(element.id)"
                     :caption="element.displayName"
                     :image="element.resource.picturePath" />
    </rui-collapsible-list-item>
  </div>
</template>

<script>
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiCollapsibleListItem from '@experiments-labs/rise_ui/src/components/ListItem/CollapsibleListItem.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import GpaCropRotationHelpButton from '../../../../common/CropRotation/HelpButton.vue'
import GpaCropRotationGroupTags from '../../../../common/CropRotation/GroupTags.vue'

import {
  determineNextGroupsFor,
  rotationGroupsWithCountFor,
} from '../../../../../helpers/RotationGroups.js'

/**
 * @typedef {object} YearlyRemovedElements - List of names, elements
 * @property {string}    names    - Concatenated list of elements names
 * @property {Element[]} elements - List of elements
 */

/**
 * @typedef {object} GroupedElements
 * @property {Element[]}                              notRemoved      - Elements that are not removed (implanted or not)
 * @property {string[]}                               removedYears    - Sorted list of years containing removed elements
 * @property {{years: string[], entries: object}}     removed         - List of removed elements, grouped by year
 * @property {{[key: string]: YearlyRemovedElements}} removed.entries - Dictionary of names and elements grouped by yeas
 */

export default {
  name: 'GpaElementsInventoryMenu',
  components: { GpaCropRotationHelpButton, GpaCropRotationGroupTags, RuiCollapsibleListItem, RuiListItem, RuiEmpty },
  props: {
    /** List of elements to display in the menu */
    elements: { required: true, type: Array },
    /** Route name for the links. an `elementId` param will be used to, so the route must match */
    routeName: { required: true, type: String },
    /** Route name portion to determine an entry is active */
    baseRouteName: { required: true, type: String },
    /** Whether to determine and display crop rotations groups */
    showRotationGroups: { required: false, type: Boolean, default: false },
  },
  computed: {
    nextRotationGroups () {
      const lastYear = new Date().getFullYear() - 1
      if (!this.groupedElements.removed.years.includes(`${lastYear}`)) return null

      return determineNextGroupsFor(this.groupedElements.removed.entries[lastYear].elements)
    },
    implantedRotationGroups () {
      const groups = rotationGroupsWithCountFor(this.groupedElements.notRemoved)
      if (Object.keys(groups).length === 0) return null

      return groups
    },
    /** @returns {GroupedElements} List of single elements matching the search */
    groupedElements () {
      const list = {
        notRemoved: [],
        removed: { years: null, entries: {} },
      }

      this.elements.forEach((e) => {
        if (!e.removedAt) {
          list.notRemoved.push(e)
          return
        }

        const year = e.removedAt.getFullYear()
        list.removed.entries[year] = list.removed.entries[year] || { names: new Set(), elements: [], rotationGroups: [] }
        list.removed.entries[year].names.add(e.resource.name)
        list.removed.entries[year].elements.push(e)
      })

      list.removed.years = Object.keys(list.removed.entries).sort().reverse()
      // Summarize names as a string and determine rotation group
      list.removed.years.forEach((year) => {
        list.removed.entries[year].names = [...list.removed.entries[year].names].join(', ')
        if (this.showRotationGroups) list.removed.entries[year].rotationGroups = rotationGroupsWithCountFor(list.removed.entries[year].elements)
      })

      return list
    },
    elementId () { return parseInt(this.$route.params.elementId, 10) },
  },
  methods: {
    isActive (elementId) {
      return this.$route.name.includes(this.baseRouteName) && this.elementId === elementId
    },
  },
}
</script>
